﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;

namespace ComTool
{
    public partial class HexTextBox : TextBox
    {
        private bool _AutoSpace;

        [Description("是否每两个16进制数后自动加一个空格")]
        public bool AutoSpace
        {
            set { _AutoSpace = value; }
            get { return _AutoSpace; }
        }

        /// <summary>
        /// 只能输入16进制数字，且每两个字节自动空格的输入文本框
        /// </summary>
        public HexTextBox()
        {
            InitializeComponent();
        }

        protected override void OnTextChanged(EventArgs e)
        {
            if (AutoSpace == true)
            { 
                
            }
        }

        protected override void OnKeyPress(KeyPressEventArgs e)
        {
            if ((e.KeyChar >= 0x30 && e.KeyChar <= 0x39) ||
                (e.KeyChar >= 0x41 && e.KeyChar <= 0x46) ||
                (e.KeyChar >= 0x61 && e.KeyChar <= 0x66)
                )
            {
                e.Handled = false;
                return;
            }
            if (e.KeyChar == 8)//退格
            {
                e.Handled = false;
                return;
            }
            e.Handled = true;
            return;
        }
    }
}
