﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ComTool.SubWin
{
    public partial class ByteCaculator : Form
    {
        public ByteCaculator()
        {
            InitializeComponent();
        }

        private void ByteCaculator_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            e.Cancel = true;
        }

        private void BToInt32_Left_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] Bts = BitConverter.GetBytes(Convert.ToInt32(BToInt32_Res.Text));
                BToInt32_B0.Text = Bts[0].ToString("X2");
                BToInt32_B1.Text = Bts[1].ToString("X2");
                BToInt32_B2.Text = Bts[2].ToString("X2");
                BToInt32_B3.Text = Bts[3].ToString("X2");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message
                                +"\n Int32最小值为："+Int32.MinValue.ToString()
                                + "\n Int32最大值为：" + Int32.MaxValue.ToString());
            }
        }

        private void BToInt32_Right_Click(object sender, EventArgs e)
        {
            string[] BToInt32 = new string[4];
            BToInt32[0] = BToInt32_B0.Text;
            BToInt32[1] = BToInt32_B1.Text;
            BToInt32[2] = BToInt32_B2.Text;
            BToInt32[3] = BToInt32_B3.Text;
            BToInt32_Res.Text = BitConverter.ToInt32(StringsToBytes(BToInt32), 0).ToString();
        }

        private void BToFloat_Left_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] Bts = BitConverter.GetBytes(Convert.ToSingle(BToFloat_Res.Text));
                BToFloat_B0.Text = Bts[0].ToString("X2");
                BToFloat_B1.Text = Bts[1].ToString("X2");
                BToFloat_B2.Text = Bts[2].ToString("X2");
                BToFloat_B3.Text = Bts[3].ToString("X2");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message
                                + "\n Float最小值为：" + Single.MinValue.ToString()
                                + "\n Float最大值为：" + Single.MaxValue.ToString());
            }
        }

        private void BToFloat_Right_Click(object sender, EventArgs e)
        {
            try
            {
                string[] BToFloat = new string[4];
                BToFloat[0] = BToFloat_B0.Text;
                BToFloat[1] = BToFloat_B1.Text;
                BToFloat[2] = BToFloat_B2.Text;
                BToFloat[3] = BToFloat_B3.Text;
                BToFloat_Res.Text = BitConverter.ToSingle(StringsToBytes(BToFloat), 0).ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void BToDouble_Left_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] Bts = BitConverter.GetBytes(Convert.ToDouble(BToDouble_Res.Text));
                BToDouble_B0.Text = Bts[0].ToString("X2");
                BToDouble_B1.Text = Bts[1].ToString("X2");
                BToDouble_B2.Text = Bts[2].ToString("X2");
                BToDouble_B3.Text = Bts[3].ToString("X2");
                BToDouble_B4.Text = Bts[4].ToString("X2");
                BToDouble_B5.Text = Bts[5].ToString("X2");
                BToDouble_B6.Text = Bts[6].ToString("X2");
                BToDouble_B7.Text = Bts[7].ToString("X2");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message
                                + "\n Double最小值为：" + Double.MinValue.ToString()
                                + "\n Double最大值为：" + Double.MaxValue.ToString());
            }
        }

        private void BToDouble_Right_Click(object sender, EventArgs e)
        {
            try
            {
                string[] BToDouble = new string[8];
                BToDouble[0] = BToDouble_B0.Text;
                BToDouble[1] = BToDouble_B1.Text;
                BToDouble[2] = BToDouble_B2.Text;
                BToDouble[3] = BToDouble_B3.Text;
                BToDouble[4] = BToDouble_B4.Text;
                BToDouble[5] = BToDouble_B5.Text;
                BToDouble[6] = BToDouble_B6.Text;
                BToDouble[7] = BToDouble_B7.Text;
                BToDouble_Res.Text = BitConverter.ToDouble(StringsToBytes(BToDouble), 0).ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 16进制字符串数组转byte数组
        /// </summary>
        /// <param name="B"></param>
        /// <returns></returns>
        private byte[] StringsToBytes(string[] B)
        {
            byte[] BToInt32 = new byte[B.Length];
            for (int i = 0; i < B.Length; i++)
            {
                BToInt32[i] = StringToByte(B[i]);
            }
            return BToInt32;
        }

        //2位HEX字符串转BYTE
        private byte StringToByte(string Str)
        {
            for (int i = Str.Length; i < 2; i++)
            {
                Str += "0";
            }
            return (byte)(Convert.ToInt32(Str, 16));
        }
    }
}
