﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ComTool.SubWin
{
    /*---------------作者：叶知秋----------------------*/
    /*---------------时间：2012年9月14日---------------*/
    /*---------------邮箱：yq@yyzq.net---------*/
    /*---------------yyzq.net--------------------------*/
    /*---------------tczhuoyou.com---------------------*
    /*任何个人均可免费修改，使用本程序，但请保留以上作者信息，谢谢！*/
    public partial class CheckWin : Form
    {
        public CheckWin()
        {
            InitializeComponent();
        }

        private void btnCalculator_Click(object sender, EventArgs e)
        {
            try
            {
                string SendData = txtDatas.Text;
                if (SendData.Length > 0)
                {
                    byte[] SendBytes=StringToByte(SendData);
                    byte[] CRC16Check = BytesCheck.GetCRC16(SendBytes, false);//计算CRC16校验值
                    byte XORCheck = BytesCheck.GetXOR(SendBytes);//计算XOR校验值
                    txtXOR.Text = string.Format("{0:x2}", XORCheck).ToUpper();
                    txtCRC16_High.Text = string.Format("{0:x2}", CRC16Check[0]).ToUpper();
                    txtCRC16_Low.Text = string.Format("{0:x2}", CRC16Check[1]).ToUpper();
                }
                else
                {
                    MessageBox.Show("请输入数据！", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            catch
            {
                MessageBox.Show("请输入正确的16进制数据！", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void CheckWin_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            e.Cancel = true;
        }

        private void btnKeyCalculator_Click(object sender, EventArgs e)
        {
            try
            {
                string SendData = txtDatas.Text;
                if (SendData.Length > 0)
                {
                    byte[] SendBytes = StringToByte(SendData);
                    byte[] poly = StringToByte(txtKeys.Text);
                    byte temp = poly[0];
                    poly[0] = poly[1];
                    poly[1] = temp;
                    byte[] CRC16Check = BytesCheck.GetCRC16ByPoly(SendBytes, BitConverter.ToUInt16(poly, 0));
                    txtCRC16_High2.Text = string.Format("{0:x2}", CRC16Check[1]).ToUpper();
                    txtCRC16_Low2.Text = string.Format("{0:x2}", CRC16Check[0]).ToUpper();
                }
                else
                {
                    MessageBox.Show("请输入数据！", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            catch
            {
                MessageBox.Show("请输入正确的16进制数据！", "错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private byte[] StringToByte(string SendData)
        {
            //剔除所有空格
            SendData = SendData.Replace(" ", "");
            if (SendData.Length % 2 == 1)
            {//奇数个字符
                SendData = SendData.Remove(SendData.Length - 1, 1);//去除末位字符
            }
            List<string> SendDataList = new List<string>();
            for (int i = 0; i < SendData.Length; i = i + 2)
            {
                SendDataList.Add(SendData.Substring(i, 2));
            }
            byte[] SendBytes = new byte[SendDataList.Count];
            for (int j = 0; j < SendBytes.Length; j++)
            {
                SendBytes[j] = (byte)(Convert.ToInt32(SendDataList[j], 16));
            }
            return SendBytes;
        }

        
    }
}
